/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 2: Separate methods volume(...) and surfaceArea(...).
 *             Some output formatting is added.
 *   
 *  Prompts the user to enter the radius of a sphere.
 *  Calculates and displays the volume and surface area.
 *  
 *  EasyReader class is used for console input. 
 *
 */

import java.text.DecimalFormat;

class Sphere
{
 // Computes the volume of a sphere with radius r.
  private static double volume(double r) 
  {
    return 4.0 / 3.0 * Math.PI * r * r * r;
  }

  // Computes the surface area of a sphere with radius r.
  private static double surfaceArea(double r)
  {
    return 4.0 * Math.PI * r * r;
  }

  public static void main(String[] args)
  {
    EasyReader console = new EasyReader();
    System.out.print("Enter the radius: ");
    double radius = console.readDouble();

    DecimalFormat f3 = new DecimalFormat("0.000");  

    System.out.println();   // displays a blank line

    System.out.println("Radius = " + f3.format(radius));
    System.out.println("Volume = " + f3.format(volume(radius)));
    System.out.println("Surface area = " + f3.format(surfaceArea(radius)));

    System.out.println();
  }
}
