/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 4: The Sphere model is implemented in this class, the same
 *             as in Project 3.    
 *             The test program with GUI is in a separate class.
 */

class Sphere
{
  private double myRadius;
  private double myCenterX;
  private double myCenterY;

  // Constructors:

  Sphere (double x, double y, double r)
  {
    myCenterX = x;
    myCenterY = y;
    myRadius = r;
  }

  // etc...

  // Accessors and modifiers:

  public double getRadius()
  {
    return myRadius;
  }

  public void setRadius(double r)
  {
    myRadius = r;
  }

  // etc...

  // Other public methods:

  public double volume()
  {
    return 4.0 / 3.0 * Math.PI * myRadius * myRadius * myRadius;
  }


  public double surfaceArea()
  {
    return 4.0 * Math.PI * myRadius * myRadius;
  }

  public String toString()
  {
    return "Sphere [Center = (" + myCenterX + ", " + myCenterY + ") Radius = " + myRadius
           + "]"; 
  }
}
