/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 4: The Sphere model is implemented in a separate class,
 *             the same as in Project 3.
 *             The test program with GUI is in this class.
 *  
 *  ExitButtonListener class is used to close the application's window.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.text.DecimalFormat;

public class SphereWindow extends JFrame
    implements ActionListener
{
  private JTextField radiusIn, volumeOut, surfAreaOut;
  private Sphere balloon;
  private DecimalFormat f3 = new DecimalFormat("0.000");

  public SphereWindow()
  {
    super("Spheres: volume and surface area");

    JPanel view = new JPanel();
    view.setLayout(new GridLayout(6, 2, 10, 10));
    view.setBorder(new EmptyBorder(10, 10, 10, 10));

    view.add(new JLabel("Radius = ", SwingConstants.RIGHT));

    radiusIn = new JTextField(8);
    radiusIn.setBackground(Color.yellow);
    radiusIn.addActionListener(this);
    view.add(radiusIn);

    view.add(new JLabel("Volume = ", SwingConstants.RIGHT));

    volumeOut = new JTextField(8);
    volumeOut.setEditable(false);
    volumeOut.setBackground(Color.white);
    view.add(volumeOut);

    view.add(new JLabel("Surface area = ", SwingConstants.RIGHT));

    surfAreaOut = new JTextField(8);
    surfAreaOut.setEditable(false);
    surfAreaOut.setBackground(Color.white);
    view.add(surfAreaOut);

    view.add (new JPanel()); // reserved

    Container c = getContentPane();
    c.add(view, BorderLayout.CENTER);

    balloon = new Sphere(0,0,100);
  }

  public void actionPerformed(ActionEvent e)
  // Called automatically when the user
  //   strikes Enter on the input field
  {
    String s = radiusIn.getText();
    double r = Double.parseDouble(s);
    balloon.setRadius(r);

    radiusIn.setText(" " + f3.format(r));
    volumeOut.setText(" " + f3.format(balloon.volume()));
    surfAreaOut.setText(" " + f3.format(balloon.surfaceArea()));
  }

  public static void main(String[] args)
  {
    SphereWindow w = new SphereWindow();
    w.setSize(300, 250);
    w.addWindowListener(new ExitButtonListener());
    w.show();
  }
}
