/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 5: The model (Sphere), view (TextView), and controller (SphereWindow)
 *             are in separate classes.
 *             When the model changes, the view is notified and updated automatically.
 *
 *  This class acts as a controller; it creates a model and a view and
 *  attaches the view to the model.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SphereWindow extends JFrame
    implements ActionListener
{
  private Sphere model;

  public SphereWindow()
  {
    super("Spheres: volume and surface area");

    model = new Sphere(0, 0, 100);
    TextView view = new TextView();
    model.addObserver(view);
    view.update(model, null);
    view.addActionListener(this);

    Container c = getContentPane();
    c.add(view);
  }

  public void actionPerformed(ActionEvent e)
  {
    JTextField t = (JTextField)e.getSource();    
    double r = Double.parseDouble(t.getText());
    model.setRadius(r);
  }

  public static void main(String[] args)
  {
    SphereWindow w = new SphereWindow();
    w.setSize(300, 250);
    w.addWindowListener(new ExitButtonListener());
    w.show();
  }
}
