/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 6: The model (Sphere), two views (TextView and GraphicsView),
 *             and controller (SphereWindow) are in separate classes.
 *             When the model changes, both views are notified and updated automatically.
 *
 *  The controller creates the model and the two views and attaches the views to
 *  the model.
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SphereWindow extends JFrame
    implements ActionListener
{
  private Sphere model;

  public SphereWindow()
  {
    super("Spheres: volume and surface area");

    model = new Sphere(0, 0, 100);

    TextView tView = new TextView();
    model.addObserver(tView);
    tView.addActionListener(this);
    tView.update(model, null);

    GraphicsView gView = new GraphicsView();
    model.addObserver(gView);
    gView.update(model, null);

    Container c = getContentPane();
    c.setLayout(new GridLayout(1, 2));
    c.add(tView);
    c.add(gView);
  }

  public void actionPerformed(ActionEvent e)
  {
    JTextField t = (JTextField)e.getSource();    
    double r = Double.parseDouble(t.getText());
    model.setRadius(r);
  }

  public static void main(String[] args)
  {
    SphereWindow w = new SphereWindow();
    w.setSize(500, 250);
    w.addWindowListener(new ExitButtonListener());
    w.show();
  }
}
