/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 7: The model (Sphere), two views (TextView and GraphicsView),
 *             and two controllers (TextController and GraphicsController)
 *             are in separate classes.
 * 
 *  This class implements the "graphics" view.
 */

import java.awt.*;
import javax.swing.*;
import java.util.Observer;
import java.util.Observable;

public class GraphicsView extends JPanel
    implements Observer
{
  public GraphicsView()
  {
    setBackground(Color.white);
  }

  private int radius;

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);

    if (radius == 0)
      return;

    g.setColor(Color.blue);
    int x0 = getWidth() / 2;
    int y0 = getHeight() / 2;
    g.drawOval(x0 - radius, y0 - radius, 2*radius, 2*radius);
    g.drawOval(x0 - radius / 2, y0 - radius, radius, 2*radius);
    g.drawOval(x0 - radius, y0 - radius / 4, 2 * radius, radius / 2);
  }

  public void update(Observable o, Object arg)
  {
    Sphere balloon = (Sphere)o;
    radius =  (int)balloon.getRadius();
    repaint();
  }
}
