/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 7: The model (Sphere), two views (TextView and GraphicsView),
 *             and two controllers (TextController and GraphicsController)
 *             are in separate classes.
 *             Each controller creates a corresponding view.
 *
 *  This class sets up the applet and creates the model and controllers.
 *
 *  Use the mouse to grab the sphere (by its border) and stretch or squeeze it.
 */
 
import java.awt.*;
import javax.swing.*;

public class SphereWindow extends JFrame
{
  public SphereWindow()
  {
    super("Spheres: volume and surface area");

    Sphere model = new Sphere(0, 0, 100);
    TextController tController = new TextController(model);
    GraphicsController gController = new GraphicsController(model);

    Container c = getContentPane();
    c.setLayout(new GridLayout(1, 2));
    c.add(tController.getView());
    c.add(gController.getView());
  }

  public static void main(String[] args)
  {
    SphereWindow w = new SphereWindow();
    w.setSize(500, 250);
    w.addWindowListener(new ExitButtonListener());
    w.show();
  }
}
