/**
 *  Case Study: "From Hello World to MVC"
 *  Authors: Maria Litvin and Gary Litvin
 *  February 2002
 *
 *  Project 7: The model (Sphere), two views (TextView and GraphicsView),
 *             and two controllers (TextController and GraphicsController)
 *             are in separate classes.
 * 
 *  This class implements the text controller.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TextController
    implements ActionListener
{
  private TextView view;
  private Sphere model;

  public TextController(Sphere balloon)
  {
    view = new TextView();
    model = balloon;
    model.addObserver(view);
    view.addActionListener(this);
    view.update(model, null);
  }

  public TextView getView()
  {
    return view;
  }

  public void actionPerformed(ActionEvent e)
  {
    JTextField t = (JTextField)e.getSource();    
    double r = Double.parseDouble(t.getText());
    model.setRadius(r);
  }
}
